﻿@page "/files"
@using DataImplementations
@using Renci.SshNet;
@using Globals;
@inject HttpClient Http
@inject IJSRuntime JSRuntime

<div class="d-flex gap-4 mx-4 mt-4 justify-space-between">
	<MudText Typo="Typo.h4">Files</MudText>
	@if (currentPath != homePath)
	{
		<MudIcon Icon="@Icons.Material.Filled.ArrowCircleLeft" Size="Size.Large" Class="cursor-pointer" Color="Color.Inherit" @onclick="@(() => GoBack())" />
	}
</div>

<MudDropContainer T="SftpFile" Items="files" Item ItemsSelector="@((item, dropzone) => item.Identifier == dropzone)" Class="d-flex flex-column flex-grow-1">
	<ChildContent>
		<MudListSubheader Class="mt-4 pb-2">Folders</MudListSubheader>
		<div class="d-flex gap-4 mx-4">
			@if (files.Any(f => f.IsDirectory))
			{
				@foreach (var folder in files.Where(f => f.IsDirectory))
				{
					<MudDropZone T="SftpFile" OnlyZone="true" Identifier="@folder.Name" @onclick="@(() => OnDirectoryClicked(folder))">
						<MudPaper Outlined="true" Class="d-flex align-center pa-3 gap-2 cursor-pointer">
							<MudIcon Icon="@Icons.Custom.Uncategorized.Folder" Color="Color.Inherit" />
							@folder.Name
						</MudPaper>
					</MudDropZone>
				}
			}
			else
			{
				<MudText Typo="Typo.body1" Class="my-2">No folders available.</MudText>
			}
		</div>
		<MudListSubheader Class="mt-4 pb-2">Files</MudListSubheader>
		<div class="d-flex gap-4 mx-4">
			@if (files.Any(f => !f.IsDirectory))
			{
				@foreach (var file in files.Where(f => !f.IsDirectory))
				{
					<MudDropZone T="SftpFile" OnlyZone="true" Identifier="@file.Name">
						<MudPaper Outlined="true" Class="d-flex align-center pa-3 gap-1.5 cursor-pointer">
							<MudIcon Icon="@Icons.Custom.FileFormats.FileDocument" Color="Color.Inherit" />
							@file.Name
							<MudIcon Icon="@Icons.Material.Filled.Download" Color="Color.Inherit" Class="ml-2 cursor-pointer" @onclick="@(() => DownloadFile(file))" />
							<MudIcon Icon="@Icons.Material.Filled.DeleteForever" Color="Color.Error" Class="cursor-pointer" @onclick="@(() => DeleteFile(file))" />
						</MudPaper>
					</MudDropZone>
				}
			}
			else
			{
				<MudText Typo="Typo.body1" Class="my-2">No files available.</MudText>
			}
		</div>
		<script>
			function downloadFileFromStream(contentType, data, filename) {
				const url = window.URL.createObjectURL(new Blob([data], { type: contentType }));
				const link = document.createElement('a');
				link.href = url;
				link.setAttribute('download', filename); // Use the actual file name
				document.body.appendChild(link);
				link.click();
				document.body.removeChild(link); // Clean up: remove the link after clicking
			}
		</script>
		<div class="d-flex gap-4 mx-4">
			@if (currentPath != homePath)
			{
				<MudFileUpload T="IBrowserFile" FilesChanged="UploadFile" Class="mt-12">
					<ButtonTemplate>
						<MudButton HtmlTag="label"
								   Variant="Variant.Filled"
								   Color="Color.Primary"
								   StartIcon="@Icons.Material.Filled.CloudUpload"
								   for="@context.Id">
							Upload Files
						</MudButton>
					</ButtonTemplate>
				</MudFileUpload>
			}
		</div>
	</ChildContent>
</MudDropContainer>

@code {
	private List<SftpFile> files = new List<SftpFile>();
	private string currentPath = "/home/sftpuser/FTP";
	private string homePath = "/home/sftpuser/FTP";

	protected override async Task OnInitializedAsync()
	{
		await LoadFiles();
	}

	private async Task LoadFiles()
	{
		files = await Http.GetFromJsonAsync<List<SftpFile>>($"Ftp/list-files?path={currentPath}");
	}

	private async Task OnDirectoryClicked(SftpFile file)
	{
		if (file.IsDirectory)
		{
			currentPath = file.FullPath;
			await LoadFiles();
		}
	}

	public async Task DownloadFile(SftpFile file)
	{
		var response = await Http.GetAsync($"Ftp/download-file?path={file.FullPath}");
		if (response.IsSuccessStatusCode)
		{
			using (var stream = await response.Content.ReadAsStreamAsync())
			using (var memoryStream = new MemoryStream())
			{
				await stream.CopyToAsync(memoryStream);
				memoryStream.Seek(0, SeekOrigin.Begin); // Rewind the memory stream after copying

				var fileName = Path.GetFileName(file.FullPath); // Assuming you can extract filename here
				var contentType = response.Content.Headers.ContentType?.ToString() ?? "application/octet-stream";

				// Pass the buffered memory stream, the content type, and the filename to JavaScript
				await JSRuntime.InvokeVoidAsync("downloadFileFromStream", contentType, memoryStream.ToArray(), fileName);
			}
		}
		else
		{
			Console.WriteLine("Error downloading file");
		}
	}

	private async Task UploadFile(IBrowserFile file)
	{
		Console.WriteLine("Upload triggered");

		using var content = new MultipartFormDataContent();
		using var fileStream = file.OpenReadStream(maxAllowedSize: 1024 * 1024 * 15);
		var fileContent = new StreamContent(fileStream);
		content.Add(fileContent, "file", file.Name);

		var response = await Http.PostAsync($"Ftp/upload-file?path={currentPath}", content);
		if (response.IsSuccessStatusCode)
		{
			Console.WriteLine("File uploaded successfully.");
			await LoadFiles();
		}
		else
		{
			Console.WriteLine("Failed to upload file.");
		}
	}

	private async Task DeleteFile(SftpFile file)
	{
		await Http.DeleteAsync($"Ftp/delete-file?path={file.FullPath}");
		await LoadFiles();
	}

	private async Task GoBack()
	{
		List<string> parts = currentPath.Split('/').ToList();

		if (currentPath != homePath) parts.RemoveAt(parts.Count - 1); currentPath = string.Join("/", parts);

		await LoadFiles();
	}
}
